Index: /palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- /palm/trunk/SOURCE/boundary_conds.f90	(revision 2231)
+++ /palm/trunk/SOURCE/boundary_conds.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Set boundary conditions on topography top using flag method.
 ! 
 ! Former revisions:
@@ -168,5 +168,5 @@
     USE indices,                                                               &
         ONLY:  nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg,             &
-               nzb, nzb_s_inner, nzb_w_inner, nzt
+               nzb, nzt, wall_flags_0
 
     USE kinds
@@ -177,10 +177,15 @@
         ONLY : nesting_mode
 
+    USE surface_mod,                                                           &
+        ONLY :  bc_h
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i !<
-    INTEGER(iwp) ::  j !<
-    INTEGER(iwp) ::  k !<
+    INTEGER(iwp) ::  i  !< grid index x direction
+    INTEGER(iwp) ::  j  !< grid index y direction
+    INTEGER(iwp) ::  k  !< grid index z direction
+    INTEGER(iwp) ::  kb !< variable to set respective boundary value, depends on facing. 
+    INTEGER(iwp) ::  l  !< running index boundary type, for up- and downward-facing walls
+    INTEGER(iwp) ::  m  !< running index surface elements
 
     REAL(wp)    ::  c_max !<
@@ -194,8 +199,18 @@
        v_p(nzb,:,:) = v_p(nzb+1,:,:)
     ENDIF
-
-    DO  i = nxlg, nxrg
-       DO  j = nysg, nyng
-          w_p(nzb_w_inner(j,i),j,i) = 0.0_wp
+!
+!-- Set zero vertical velocity at topography top (l=0), or bottom (l=1) in case
+!-- of downward-facing surfaces. 
+    DO  l = 0, 1
+!
+!--    Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--    for downward-facing surfaces at topography bottom (k+1). 
+       kb = MERGE( -1, 1, l == 0 )
+       !$OMP PARALLEL DO PRIVATE( i, j, k )
+       DO  m = 1, bc_h(l)%ns
+          i = bc_h(l)%i(m)            
+          j = bc_h(l)%j(m)
+          k = bc_h(l)%k(m)
+          w_p(k+kb,j,i) = 0.0_wp
        ENDDO
     ENDDO
@@ -216,17 +231,36 @@
 
 !
-!-- Temperature at bottom boundary.
+!-- Temperature at bottom and top boundary.
 !-- In case of coupled runs (ibc_pt_b = 2) the temperature is given by
 !-- the sea surface temperature of the coupled ocean model.
+!-- Dirichlet
     IF ( ibc_pt_b == 0 )  THEN
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             pt_p(nzb_s_inner(j,i),j,i) = pt(nzb_s_inner(j,i),j,i)
+       DO  l = 0, 1
+!
+!--       Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--       for downward-facing surfaces at topography bottom (k+1). 
+          kb = MERGE( -1, 1, l == 0 )
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(l)%ns
+             i = bc_h(l)%i(m)            
+             j = bc_h(l)%j(m)
+             k = bc_h(l)%k(m)
+             pt_p(k+kb,j,i) = pt(k+kb,j,i)
           ENDDO
        ENDDO
+!
+!-- Neumann, zero-gradient
     ELSEIF ( ibc_pt_b == 1 )  THEN
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             pt_p(nzb_s_inner(j,i),j,i) = pt_p(nzb_s_inner(j,i)+1,j,i)
+       DO  l = 0, 1
+!
+!--       Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--       for downward-facing surfaces at topography bottom (k+1). 
+          kb = MERGE( -1, 1, l == 0 )
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(l)%ns
+             i = bc_h(l)%i(m)            
+             j = bc_h(l)%j(m)
+             k = bc_h(l)%k(m)
+             pt_p(k+kb,j,i) = pt_p(k,j,i)
           ENDDO
        ENDDO
@@ -253,9 +287,19 @@
 !-- Generally Neumann conditions with de/dz=0 are assumed
     IF ( .NOT. constant_diffusion )  THEN
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             e_p(nzb_s_inner(j,i),j,i) = e_p(nzb_s_inner(j,i)+1,j,i)
+
+       DO  l = 0, 1
+!
+!--       Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--       for downward-facing surfaces at topography bottom (k+1). 
+          kb = MERGE( -1, 1, l == 0 )
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(l)%ns
+             i = bc_h(l)%i(m)            
+             j = bc_h(l)%j(m)
+             k = bc_h(l)%k(m)
+             e_p(k+kb,j,i) = e_p(k,j,i)
           ENDDO
        ENDDO
+
        IF ( .NOT. nest_domain )  THEN
           e_p(nzt+1,:,:) = e_p(nzt,:,:)
@@ -268,11 +312,18 @@
 !
 !--    Bottom boundary: Neumann condition because salinity flux is always
-!--    given
-       DO  i = nxlg, nxrg
-          DO  j = nysg, nyng
-             sa_p(nzb_s_inner(j,i),j,i) = sa_p(nzb_s_inner(j,i)+1,j,i)
+!--    given.
+       DO  l = 0, 1
+!
+!--       Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--       for downward-facing surfaces at topography bottom (k+1). 
+          kb = MERGE( -1, 1, l == 0 )
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(l)%ns
+             i = bc_h(l)%i(m)            
+             j = bc_h(l)%j(m)
+             k = bc_h(l)%k(m)
+             sa_p(k+kb,j,i) = sa_p(k,j,i)
           ENDDO
        ENDDO
-
 !
 !--    Top boundary: Dirichlet or Neumann
@@ -291,14 +342,43 @@
 !
 !--    Surface conditions for constant_humidity_flux
+!--    Run loop over all non-natural and natural walls. Note, in wall-datatype
+!--    the k coordinate belongs to the atmospheric grid point, therefore, set
+!--    q_p at k-1
        IF ( ibc_q_b == 0 ) THEN
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                q_p(nzb_s_inner(j,i),j,i) = q(nzb_s_inner(j,i),j,i)
+
+          DO  l = 0, 1
+!
+!--          Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--          for downward-facing surfaces at topography bottom (k+1). 
+             kb = MERGE( -1, 1, l == 0 )
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, bc_h(l)%ns
+                i = bc_h(l)%i(m)            
+                j = bc_h(l)%j(m)
+                k = bc_h(l)%k(m)
+                q_p(k+kb,j,i) = q(k+kb,j,i)
              ENDDO
           ENDDO
+          
        ELSE
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                q_p(nzb_s_inner(j,i),j,i) = q_p(nzb_s_inner(j,i)+1,j,i)
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(0)%ns
+             i = bc_h(0)%i(m)            
+             j = bc_h(0)%j(m)
+             k = bc_h(0)%k(m)
+             q_p(k-1,j,i) = q_p(k,j,i)
+          ENDDO
+          
+          DO  l = 0, 1
+!
+!--          Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--          for downward-facing surfaces at topography bottom (k+1). 
+             kb = MERGE( -1, 1, l == 0 )
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, bc_h(l)%ns
+                i = bc_h(l)%i(m)            
+                j = bc_h(l)%j(m)
+                k = bc_h(l)%k(m)
+                q_p(k+kb,j,i) = q_p(k,j,i)
              ENDDO
           ENDDO
@@ -315,9 +395,14 @@
 !             
 !--       Surface conditions rain water (Dirichlet)
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                qr_p(nzb_s_inner(j,i),j,i) = 0.0_wp
-                nr_p(nzb_s_inner(j,i),j,i) = 0.0_wp
-             ENDDO
+!--       Run loop over all non-natural and natural walls. Note, in wall-datatype
+!--       the k coordinate belongs to the atmospheric grid point, therefore, set
+!--       qr_p and nr_p at k-1
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(0)%ns
+             i = bc_h(0)%i(m)            
+             j = bc_h(0)%j(m)
+             k = bc_h(0)%k(m)
+             qr_p(k-1,j,i) = 0.0_wp
+             nr_p(k-1,j,i) = 0.0_wp
           ENDDO
 !
@@ -334,14 +419,43 @@
 !
 !--    Surface conditions for constant_humidity_flux
+!--    Run loop over all non-natural and natural walls. Note, in wall-datatype
+!--    the k coordinate belongs to the atmospheric grid point, therefore, set
+!--    s_p at k-1
        IF ( ibc_s_b == 0 ) THEN
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                s_p(nzb_s_inner(j,i),j,i) = s(nzb_s_inner(j,i),j,i)
+          
+          DO  l = 0, 1
+!
+!--          Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--          for downward-facing surfaces at topography bottom (k+1). 
+             kb = MERGE( -1, 1, l == 0 )
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, bc_h(l)%ns
+                i = bc_h(l)%i(m)            
+                j = bc_h(l)%j(m)
+                k = bc_h(l)%k(m)
+                s_p(k+kb,j,i) = s(k+kb,j,i)
              ENDDO
           ENDDO
+          
        ELSE
-          DO  i = nxlg, nxrg
-             DO  j = nysg, nyng
-                s_p(nzb_s_inner(j,i),j,i) = s_p(nzb_s_inner(j,i)+1,j,i)
+          !$OMP PARALLEL DO PRIVATE( i, j, k )
+          DO  m = 1, bc_h(0)%ns
+             i = bc_h(0)%i(m)            
+             j = bc_h(0)%j(m)
+             k = bc_h(0)%k(m)
+             s_p(k-1,j,i) = s_p(k,j,i)
+          ENDDO
+          
+          DO  l = 0, 1
+!
+!--          Set kb, for upward-facing surfaces value at topography top (k-1) is set,
+!--          for downward-facing surfaces at topography bottom (k+1). 
+             kb = MERGE( -1, 1, l == 0 )
+             !$OMP PARALLEL DO PRIVATE( i, j, k )
+             DO  m = 1, bc_h(l)%ns
+                i = bc_h(l)%i(m)            
+                j = bc_h(l)%j(m)
+                k = bc_h(l)%k(m)
+                s_p(k+kb,j,i) = s_p(k,j,i)
              ENDDO
           ENDDO
@@ -394,5 +508,5 @@
     IF ( outflow_s )  THEN
        pt_p(:,nys-1,:)     = pt_p(:,nys,:)
-       IF ( .NOT. constant_diffusion     )  e_p(:,nys-1,:) = e_p(:,nys,:)
+       IF ( .NOT. constant_diffusion )  e_p(:,nys-1,:) = e_p(:,nys,:)
        IF ( humidity )  THEN
           q_p(:,nys-1,:) = q_p(:,nys,:)
Index: /palm/trunk/SOURCE/buoyancy.f90
===================================================================
--- /palm/trunk/SOURCE/buoyancy.f90	(revision 2231)
+++ /palm/trunk/SOURCE/buoyancy.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -131,5 +131,5 @@
        USE indices,                                                            &
            ONLY:  nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nzb,       &
-                  nzb_s_inner, nzt
+                  nzt, wall_flags_0
 
        USE kinds
@@ -157,10 +157,11 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb_s_inner(j,i)+1, nzt-1
-                   tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5_wp * &
-                          (                                                    &
+                DO  k = nzb+1, nzt-1
+                   tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5_wp *  &
+                          (                                                     &
                              ( var(k,j,i)   - ref_state(k) )   / ref_state(k) + &
                              ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1) &
-                          )
+                          ) * MERGE( 1.0_wp, 0.0_wp,                            &
+                                     BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDDO
              ENDDO
@@ -178,9 +179,11 @@
              DO  i = nxlu, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt-1
-                      tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *      &
+                   DO  k = nzb+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *         &
                            0.5_wp * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
                                     - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
-                                    ) / pt_surface
+                                    ) / pt_surface                                &
+                                      * MERGE( 1.0_wp, 0.0_wp,                    &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                    ENDDO
                 ENDDO
@@ -191,9 +194,11 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_s_inner(j,i)+1, nzt-1
-                      tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *      &
+                   DO  k = nzb+1, nzt-1
+                      tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *         &
                            0.5_wp * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
                                     - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
-                                    ) / pt_surface
+                                    ) / pt_surface                                &
+                                      * MERGE( 1.0_wp, 0.0_wp,                    &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                    ENDDO
                 ENDDO
@@ -231,5 +236,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzb_s_inner, nzt
+           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -256,9 +261,11 @@
 !
 !--       Normal case: horizontal surface
-          DO  k = nzb_s_inner(j,i)+1, nzt-1
+          DO  k = nzb+1, nzt-1
               tend(k,j,i) = tend(k,j,i) + atmos_ocean_sign * g * 0.5_wp * (    &
                         ( var(k,j,i)   - ref_state(k)   ) / ref_state(k)   +   &
                         ( var(k+1,j,i) - ref_state(k+1) ) / ref_state(k+1)     &
-                                                                          )
+                                                                          )    &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
           ENDDO
 
@@ -272,18 +279,22 @@
           IF ( wind_component == 1 )  THEN
 
-             DO  k = nzb_s_inner(j,i)+1, nzt-1
-                tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *            &
+             DO  k = nzb+1, nzt-1
+                tend(k,j,i) = tend(k,j,i) + g * sin_alpha_surface *               &
                            0.5_wp * ( ( pt(k,j,i-1)         + pt(k,j,i)         ) &
                                     - ( pt_slope_ref(k,i-1) + pt_slope_ref(k,i) ) &
-                                    ) / pt_surface
+                                    ) / pt_surface                                &
+                                      * MERGE( 1.0_wp, 0.0_wp,                    &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
              ENDDO
 
           ELSEIF ( wind_component == 3 )  THEN
 
-             DO  k = nzb_s_inner(j,i)+1, nzt-1
-                tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *            &
+             DO  k = nzb+1, nzt-1
+                tend(k,j,i) = tend(k,j,i) + g * cos_alpha_surface *               &
                            0.5_wp * ( ( pt(k,j,i)         + pt(k+1,j,i)         ) &
                                     - ( pt_slope_ref(k,i) + pt_slope_ref(k+1,i) ) &
-                                    ) / pt_surface
+                                    ) / pt_surface                                &
+                                      * MERGE( 1.0_wp, 0.0_wp,                    &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
              ENDDO
 
Index: /palm/trunk/SOURCE/calc_liquid_water_content.f90
===================================================================
--- /palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 2231)
+++ /palm/trunk/SOURCE/calc_liquid_water_content.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -83,5 +83,5 @@
 
     USE indices,                                                               &
-        ONLY:  nxlg, nxrg, nyng, nysg, nzb_s_inner, nzt
+        ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt, wall_flags_0
 
     USE kinds
@@ -103,5 +103,5 @@
     DO  i = nxlg, nxrg
        DO  j = nysg, nyng
-          DO  k = nzb_s_inner(j,i)+1, nzt
+          DO  k = nzb+1, nzt
 
 !
@@ -131,15 +131,25 @@
              IF ( microphysics_seifert )  THEN
                 IF ( ( q(k,j,i) - q_s - qr(k,j,i) ) > 0.0_wp ) THEN
-                   qc(k,j,i) = q(k,j,i) - q_s - qr(k,j,i)
-                   ql(k,j,i) = qc(k,j,i) + qr(k,j,i)
+                   qc(k,j,i) = ( q(k,j,i) - q_s - qr(k,j,i) )                  &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ql(k,j,i) = ( qc(k,j,i) + qr(k,j,i) )                       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ELSE
                    IF ( q(k,j,i) < qr(k,j,i) )  q(k,j,i) = qr(k,j,i)
                    qc(k,j,i) = 0.0_wp 
-                   ql(k,j,i) = qr(k,j,i)
+                   ql(k,j,i) = qr(k,j,i)                                       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDIF
              ELSE
                 IF ( ( q(k,j,i) - q_s ) > 0.0_wp ) THEN
-                   qc(k,j,i) = q(k,j,i) - q_s
-                   ql(k,j,i) = qc(k,j,i)
+                   qc(k,j,i) = ( q(k,j,i) - q_s )                              &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
+                   ql(k,j,i) = qc(k,j,i)                                       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ELSE
                    qc(k,j,i) = 0.0_wp
Index: /palm/trunk/SOURCE/calc_mean_profile.f90
===================================================================
--- /palm/trunk/SOURCE/calc_mean_profile.f90	(revision 2231)
+++ /palm/trunk/SOURCE/calc_mean_profile.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -75,5 +75,6 @@
 
        USE indices,                                                            &
-           ONLY:  ngp_2dh_s_inner, nxl, nxr, nyn, nys, nzb, nzb_s_inner, nzt
+           ONLY:  ngp_2dh_s_inner, nxl, nxr, nyn, nys, nzb, nzb, nzt,          &
+                  wall_flags_0
 
        USE kinds
@@ -118,6 +119,8 @@
           DO  i = nxl, nxr
              DO  j =  nys, nyn
-                DO  k = nzb_s_inner(j,i), nzt+1
-                   sums_l(k,pr,tn) = sums_l(k,pr,tn) + var(k,j,i)
+                DO  k = nzb, nzt+1
+                   sums_l(k,pr,tn) = sums_l(k,pr,tn) + var(k,j,i)              &
+                                     * MERGE( 1.0_wp, 0.0_wp,                  &
+                                              BTEST( wall_flags_0(k,j,i), 22 ) )
                 ENDDO
              ENDDO
Index: /palm/trunk/SOURCE/calc_radiation.f90
===================================================================
--- /palm/trunk/SOURCE/calc_radiation.f90	(revision 2231)
+++ /palm/trunk/SOURCE/calc_radiation.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -105,5 +105,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
 
        USE kinds
@@ -153,5 +153,5 @@
              blackbody_emission(nzb) = sigma * temperature**4
 
-             DO  k = nzb_s_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
 
                 k_help = ( nzt+nzb+1 ) - k
@@ -163,5 +163,7 @@
 
                 temperature     = pt(k,j,i) * t_d_pt(k) + l_d_cp * ql(k,j,i)
-                blackbody_emission(k) = sigma * temperature**4
+                blackbody_emission(k) = sigma * temperature**4                 &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
 
              ENDDO
@@ -179,5 +181,5 @@
              impinging_flux_at_top = blackbody_emission(nzb) - 100.0_wp
 
-             DO  k = nzb_s_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
 !
 !--             Save some computational time, but this may cause load
@@ -222,5 +224,7 @@
                    tend(k,j,i) = tend(k,j,i) -                                 &
                                 ( pt_d_t(k) / ( rho_surface * cp ) *           &
-                                  ( df_p - df_m ) / dzw(k) )
+                                  ( df_p - df_m ) / dzw(k) )                   &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
 
                 ENDIF
@@ -250,5 +254,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
 
        USE kinds
@@ -295,5 +299,5 @@
        blackbody_emission(nzb) = sigma * temperature**4
 
-       DO  k = nzb_s_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
           k_help = ( nzt+nzb+1 ) - k
           lwp_ground(k)   = lwp_ground(k-1) + rho_surface * ql(k,j,i) * dzw(k)
@@ -303,5 +307,7 @@
 
           temperature     = pt(k,j,i) * t_d_pt(k) + l_d_cp * ql(k,j,i)
-          blackbody_emission(k) = sigma * temperature**4
+          blackbody_emission(k) = sigma * temperature**4                       &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
 
        ENDDO
@@ -318,5 +324,5 @@
        impinging_flux_at_top = blackbody_emission(nzb) - 100.0_wp
 
-       DO  k = nzb_s_inner(j,i)+1, nzt
+       DO  k = nzb+1, nzt
 !
 !--       Store some computational time,
@@ -356,5 +362,7 @@
 !--          Compute tendency term         
              tend(k,j,i) = tend(k,j,i) - ( pt_d_t(k) / ( rho_surface * cp ) *  &
-                                         ( df_p - df_m ) / dzw(k) )
+                                         ( df_p - df_m ) / dzw(k) )            &
+                                      * MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
 
           ENDIF
Index: /palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- /palm/trunk/SOURCE/check_parameters.f90	(revision 2231)
+++ /palm/trunk/SOURCE/check_parameters.f90	(revision 2232)
@@ -466,5 +466,5 @@
     USE indices
     USE land_surface_model_mod,                                                &
-        ONLY: land_surface, lsm_check_data_output, lsm_check_data_output_pr,   &
+        ONLY: lsm_check_data_output, lsm_check_data_output_pr,                 &
               lsm_check_parameters
 
@@ -859,4 +859,12 @@
                         'momentum_advec = "ws-scheme"'
        CALL message( 'check_parameters', 'PA0447', 1, 2, 0, 6, 0 )
+    ENDIF
+    IF ( TRIM( approximation ) == 'anelastic'   .AND.   &
+         TRIM( psolver ) == 'multigrid' )  THEN
+       message_string = 'Anelastic approximation currently only supports: ' // &
+                        'psolver = "poisfft", ' // &
+                        'psolver = "sor" and ' // &
+                        'psolver = "multigrid_noopt"'
+       CALL message( 'check_parameters', 'PA0448', 1, 2, 0, 6, 0 )
     ENDIF
     IF ( TRIM( approximation ) == 'anelastic'   .AND.   &
Index: /palm/trunk/SOURCE/coriolis.f90
===================================================================
--- /palm/trunk/SOURCE/coriolis.f90	(revision 2231)
+++ /palm/trunk/SOURCE/coriolis.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -102,6 +102,5 @@
            
        USE indices,                                                            &
-           ONLY:  nxl, nxlu, nxr, nyn, nys, nysv, nzb_u_inner, nzb_v_inner,    &
-                  nzb_w_inner, nzt
+           ONLY:  nxl, nxlu, nxr, nyn, nys, nysv, nzb, nzt, wall_flags_0
                    
        USE kinds
@@ -110,9 +109,9 @@
 
        INTEGER(iwp) ::  component  !< 
-       INTEGER(iwp) ::  i          !< 
-       INTEGER(iwp) ::  j          !< 
-       INTEGER(iwp) ::  k          !< 
-
-
+       INTEGER(iwp) ::  i          !< running index x direction 
+       INTEGER(iwp) ::  j          !< running index y direction 
+       INTEGER(iwp) ::  k          !< running index z direction 
+
+       REAL(wp)     ::  flag       !< flag to mask topography
 !
 !--    Compute Coriolis terms for the three velocity components
@@ -124,12 +123,17 @@
              DO  i = nxlu, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_u_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
+!
+!--                    Predetermine flag to mask topography
+                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
+                                    BTEST( wall_flags_0(k,j,i), 1 ) )
+
                       tend(k,j,i) = tend(k,j,i) + f  *    ( 0.25_wp *          &
                                    ( v(k,j,i-1) + v(k,j,i) + v(k,j+1,i-1) +    &
-                                     v(k,j+1,i) ) - vg(k) )                    &
+                                     v(k,j+1,i) ) - vg(k)   ) * flag           &
                                                 - fs *    ( 0.25_wp *          &
                                    ( w(k-1,j,i-1) + w(k-1,j,i) + w(k,j,i-1) +  &
-                                     w(k,j,i)   ) &
-                                                          )
+                                     w(k,j,i)   )                              &
+                                                          )   * flag
                    ENDDO
                 ENDDO
@@ -141,8 +145,10 @@
              DO  i = nxl, nxr
                 DO  j = nysv, nyn
-                   DO  k = nzb_v_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tend(k,j,i) = tend(k,j,i) - f *     ( 0.25_wp *          &
                                    ( u(k,j-1,i) + u(k,j,i) + u(k,j-1,i+1) +    &
-                                     u(k,j,i+1) ) - ug(k) )
+                                     u(k,j,i+1) ) - ug(k) ) *                  &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 2 ) )
                    ENDDO
                 ENDDO
@@ -154,8 +160,10 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_w_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tend(k,j,i) = tend(k,j,i) + fs * 0.25_wp *               &
                                    ( u(k,j,i) + u(k+1,j,i) + u(k,j,i+1) +      &
-                                     u(k+1,j,i+1) )
+                                     u(k+1,j,i+1) ) *                          &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 3 ) )
                    ENDDO
                 ENDDO
@@ -186,5 +194,5 @@
            
        USE indices,                                                            &
-           ONLY:  nzb_u_inner, nzb_v_inner, nzb_w_inner, nzt
+           ONLY:  nzb, nzt, wall_flags_0
            
        USE kinds
@@ -193,7 +201,9 @@
 
        INTEGER(iwp) ::  component  !< 
-       INTEGER(iwp) ::  i          !<
-       INTEGER(iwp) ::  j          !< 
-       INTEGER(iwp) ::  k          !<
+       INTEGER(iwp) ::  i          !< running index x direction 
+       INTEGER(iwp) ::  j          !< running index y direction 
+       INTEGER(iwp) ::  k          !< running index z direction 
+
+       REAL(wp)     ::  flag       !< flag to mask topography
 
 !
@@ -204,11 +214,15 @@
 !--       u-component
           CASE ( 1 )
-             DO  k = nzb_u_inner(j,i)+1, nzt
-                tend(k,j,i) = tend(k,j,i) + f  *    ( 0.25_wp *                &
+             DO  k = nzb+1, nzt
+!
+!--             Predetermine flag to mask topography
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 1 ) )
+
+                tend(k,j,i) = tend(k,j,i) + f  *     ( 0.25_wp *               &
                                 ( v(k,j,i-1) + v(k,j,i) + v(k,j+1,i-1) +       &
-                                  v(k,j+1,i) ) - vg(k) )                       &
+                                  v(k,j+1,i) ) - vg(k) ) * flag                &
                                           - fs *    ( 0.25_wp *                &
                                 ( w(k-1,j,i-1) + w(k-1,j,i) + w(k,j,i-1) +     &
-                                  w(k,j,i)   ) )
+                                  w(k,j,i)   )      ) * flag
              ENDDO
 
@@ -216,8 +230,10 @@
 !--       v-component
           CASE ( 2 )
-             DO  k = nzb_v_inner(j,i)+1, nzt
-                tend(k,j,i) = tend(k,j,i) - f *     ( 0.25_wp *                &
+             DO  k = nzb+1, nzt
+                tend(k,j,i) = tend(k,j,i) - f *        ( 0.25_wp *             &
                                 ( u(k,j-1,i) + u(k,j,i) + u(k,j-1,i+1) +       &
-                                  u(k,j,i+1) ) - ug(k) )
+                                  u(k,j,i+1) ) - ug(k) ) *                     &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 2 ) )
              ENDDO
 
@@ -225,8 +241,10 @@
 !--       w-component
           CASE ( 3 )
-             DO  k = nzb_w_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
                 tend(k,j,i) = tend(k,j,i) + fs * 0.25_wp *                     &
                                 ( u(k,j,i) + u(k+1,j,i) + u(k,j,i+1) +         &
-                                  u(k+1,j,i+1) )
+                                  u(k+1,j,i+1) ) *                             &
+                                      MERGE( 1.0_wp, 0.0_wp,                   &
+                                             BTEST( wall_flags_0(k,j,i), 3 ) )
              ENDDO
 
